import pygtk
pygtk.require('2.0')
import gtk, gobject, cairo
import framework
import serial
import threading, time

stop = False
def read_serial(widget):
  ser = serial.Serial('/dev/ttyUSB0', 9600, timeout=1)
  while not stop:
    try:
      l = ser.readline().rstrip()
      if l:
        v = (time.time(), int(l))
        gtk.gdk.threads_enter()
        widget.update_data(v)
        gtk.gdk.threads_leave()
    except ValueError:
      pass
  ser.close()

class Plot(framework.Screen):
  draw_interval = 0.10
  time_window = 2.0
  last_draw = time.time()
  data = []

  def draw(self, cr, width, height):
    cr.set_source_rgb(1, 1, 1)
    cr.rectangle(0, 0, width, height)
    cr.fill()
    cr.translate(0, 0)
    cr.scale(width / 1.0, height / 1.0)
    cr.set_line_width(0.005)
    cr.set_source_rgb(0.0, 0.0, 1.0)
    cr.move_to(0.0, 0.25)
    cr.line_to(1.0, 0.25)
    cr.move_to(0.0, 0.5)
    cr.line_to(1.0, 0.5)
    cr.move_to(0.0, 0.75)
    cr.line_to(1.0, 0.75)
    cr.stroke()

    if self.data:
      cr.set_line_width(0.002)
      cr.set_source_rgb(0.0, 0.0, 0.0)
      t0 = time.time()
      while self.data[0][0] < t0 - self.time_window:
        self.data.pop(0)
      cr.move_to((self.data[0][0] - t0 + self.time_window)/self.time_window, 1.0 - float(self.data[0][1]) / 1024.0)
      for t,d in self.data[1:]:
        cr.line_to((t - t0 + self.time_window)/self.time_window, 1.0 - float(d) / 1024.0)
      cr.stroke()

  def update_data(self, data):
    self.data.append(data)
    if time.time() - self.last_draw >= self.draw_interval:
      self.queue_draw()
      self.last_draw = time.time()

gobject.threads_init()

plot = Plot()
reader = threading.Thread(target=read_serial, args=(plot,))
reader.start()
window = gtk.Window()
window.connect("delete-event", gtk.main_quit)
plot.show()
window.add(plot)
window.present()
gtk.gdk.threads_init()
gtk.gdk.threads_enter()
try:
  gtk.main()
except KeyboardInterrupt:
  stop = True
gtk.gdk.threads_leave()
stop = True
